<?php

use Contao\Backend;
use Contao\BackendUser;
use Contao\DC_Table;

/**
 * Table tl_popup_set 
 */
$GLOBALS['TL_DCA']['tl_popup_set'] = array
    (
    // Config
    'config' => array
        (
        'dataContainer' => DC_Table::class,
        'ctable' => array('tl_popup'),
        'switchToEdit' => true,
        'enableVersioning' => true,
        'sql' => array
            (
            'keys' => array
                (
                'id' => 'primary'
            )
        )
    ),
    // List
    'list' => array
        (
        'sorting' => array
            (
            'mode' => 1,
            'fields' => array('title'),
            'flag' => 1,
            'panelLayout' => 'search,limit'
        ),
        'label' => array
            (
            'fields' => array('title'),
            'format' => '%s'
        ),
        'operations' => array
            (

        )
    ),
    // Palettes
    'palettes' => array
        (
        '__selector__' => array('protected'),
        'default' => '{title_legend},title;{protected_legend:hide},protected'
    ),
    // Fields
    'fields' => array
        (
        'id' => array
            (
            'sql' => "int(10) unsigned NOT NULL auto_increment"
        ),
        'tstamp' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'title' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['title'],
            'exclude' => true,
            'search' => true,
            'sorting' => true,
            'flag' => 1,
            'inputType' => 'text',
            'eval' => array('mandatory' => true, 'maxlength' => 255),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'protected' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['protected'],
            'exclude' => true,            
            'inputType' => 'checkbox',
            'eval' => array('submitOnChange' => true),
            'sql' => "char(1) NOT NULL default ''"
        ),
        'groups' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['groups'],
            'exclude' => true,
            'inputType' => 'checkbox',
            'foreignKey' => 'tl_member_group.name',
            'eval' => array('mandatory' => true, 'multiple' => true),
            'sql' => "blob NULL",
            'relation' => array('type' => 'hasMany', 'load' => 'lazy')
        )        
    )
);

/**
 * Class tl_popup_set
 */
class tl_popup_set extends Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import(BackendUser::class, 'User');
	}

}
